<template>
  <div class="container">
    <h2>New Item</h2>
    <b-form-input
      v-model="name"
      required
      placeholder="item name"
      type="text">
    </b-form-input>
    <b-form-input
      v-model="cost"
      required
      placeholder="item cost"
      type="number">
    </b-form-input>
    <b-textarea
      v-model="description"
      placeholder="item description"
      :rows="3">
    </b-textarea>
    <div class="buttons">
      <b-button-group>
        <b-button 
          variant="success"
          @click="submit"
          :disabled="!valid">Submit</b-button>
        <b-button 
          variant="danger"
          @click="cancel">Cancel</b-button>
      </b-button-group>
    </div>
    <div>
      <b-alert
        :show="error != ''"
        variant="danger">
        {{ error }}
      </b-alert>
    </div>
  </div>
</template>

<script>
export default {
  data() {
    return {
      name: '',
      cost: '',
      description: '',
      error: ''
    };
  },
  computed: {
    valid() {
      return this.name.length * this.cost * this.description.length > 0;
    }
  },
  methods: {
    submit() {
      let data = {
        item: {
          name: this.name,
          cost: this.cost,
          description: this.description
        }
      },
      ins = this;

      this.error = '';

      this.$axios({
        method: 'post',
        url: 'http://localhost:3000/items',
        data: data
      })
        .then(res => {
          ins.$router.go();
        })
        .catch(err => {
          ins.error = 'Ocorreu um erro... :(';
        })
    },
    cancel() {
      this.name = '';
      this.cost = '';
    }
  }
}
</script>

<style>
.container {
  max-width: 35vw;
  border: 0.2rem solid lightgray;
  border-radius: 10px;
  padding: 1rem;
}

.buttons {
  display: flex;
  justify-content: center;
}
</style>
